import { defineComponent as G, ref as d, computed as l, watch as J, createElementBlock as n, openBlock as o, normalizeStyle as O, unref as x, createCommentVNode as u, createElementVNode as s, normalizeClass as f, renderSlot as h, createTextVNode as m, toDisplayString as p, withKeys as U, withModifiers as X, withDirectives as $, vShow as L } from "vue";
import { useInject as Y, useSlotsExist as Z } from "../utils/index.js";
const _ = {
  key: 0,
  class: "input-prefix"
}, ee = ["type", "value", "placeholder", "maxlength", "disabled", "onKeydown"], te = {
  key: 1,
  class: "input-suffix"
}, ae = {
  class: "eye-svg",
  focusable: "false",
  "data-icon": "eye",
  width: "1em",
  height: "1em",
  fill: "currentColor",
  "aria-hidden": "true",
  viewBox: "64 64 896 896"
}, ne = {
  class: "eye-svg",
  focusable: "false",
  "data-icon": "eye-invisible",
  width: "1em",
  height: "1em",
  fill: "currentColor",
  "aria-hidden": "true",
  viewBox: "64 64 896 896"
}, oe = {
  key: 2,
  class: "input-count"
}, le = {
  key: 3,
  class: "suffix-item"
}, ie = /* @__PURE__ */ G({
  __name: "Input",
  props: {
    width: { default: "100%" },
    size: { default: "middle" },
    addonBefore: { default: void 0 },
    addonAfter: { default: void 0 },
    prefix: { default: void 0 },
    suffix: { default: void 0 },
    allowClear: { type: Boolean, default: !1 },
    password: { type: Boolean, default: !1 },
    disabled: { type: Boolean, default: !1 },
    placeholder: { default: void 0 },
    maxlength: { default: void 0 },
    showCount: { type: Boolean, default: !1 },
    value: { default: void 0 },
    valueModifiers: { default: () => ({}) }
  },
  emits: ["update:value", "change", "enter"],
  setup(E, { emit: A }) {
    const t = E, b = d(null), w = d(!1), y = d(!1), c = d(), r = d(!1), { colorPalettes: z, shadowColor: S } = Y("Input"), i = A, v = Z(["prefix", "suffix", "addonBefore", "addonAfter"]), I = l(() => typeof t.width == "number" ? `${t.width}px` : t.width), B = l(() => !t.disabled && t.allowClear), q = l(() => t.maxlength ? `${t.value ? t.value.length : 0} / ${t.maxlength}` : t.value ? t.value.length : 0), N = l(() => v.prefix || t.prefix), k = l(() => v.suffix || t.suffix), P = l(() => B.value || t.password || t.showCount || k.value), g = l(() => v.addonBefore || t.addonBefore), C = l(() => v.addonAfter || t.addonAfter), M = l(() => "lazy" in t.valueModifiers);
    J(
      () => t.value,
      (e) => {
        c.value !== e && (c.value = e);
      },
      {
        immediate: !0
      }
    );
    function V() {
      w.value = !0;
    }
    function K() {
      w.value = !1;
    }
    function Q() {
      y.value = !0;
    }
    function D() {
      y.value = !1;
    }
    function F(e) {
      const a = e.target;
      c.value = a.value, M.value || (i("update:value", a.value), i("change", e));
    }
    function R(e) {
      const a = e.target;
      a.value !== t.value && (i("update:value", a.value), i("change", e));
    }
    function W(e) {
      var a;
      if (i("enter", e), M.value) {
        const T = new Event("change");
        (a = e.target) == null || a.dispatchEvent(T);
      }
    }
    function j() {
      var e;
      i("update:value", ""), (e = b.value) == null || e.focus();
    }
    function H() {
      r.value = !r.value;
    }
    return (e, a) => (o(), n("div", {
      class: "m-input",
      style: O(`
      --input-width: ${I.value};
      --input-primary-color-hover: ${x(z)[4]};
      --input-primary-color-focus: ${x(z)[4]};
      --input-primary-shadow-color: ${x(S)};
    `)
    }, [
      g.value ? (o(), n("span", {
        key: 0,
        class: f(["input-addon", { "addon-before": g.value }])
      }, [
        h(e.$slots, "addonBefore", {}, () => [
          m(p(e.addonBefore), 1)
        ], !0)
      ], 2)) : u("", !0),
      s("div", {
        tabindex: "1",
        class: f(["input-wrap", [
          `input-${e.size}`,
          {
            "input-before": g.value,
            "input-after": C.value,
            "input-disabled": e.disabled
          }
        ]]),
        onMouseenter: V,
        onMouseleave: K
      }, [
        a[3] || (a[3] = s("div", { class: "input-border" }, null, -1)),
        s("div", {
          class: f(["input-border-state", { "input-hover": w.value, "input-focus": y.value }])
        }, null, 2),
        N.value ? (o(), n("span", _, [
          h(e.$slots, "prefix", {}, () => [
            m(p(e.prefix), 1)
          ], !0)
        ])) : u("", !0),
        s("input", {
          ref_key: "inputRef",
          ref: b,
          class: "input-item",
          type: e.password && !r.value ? "password" : "text",
          value: c.value,
          placeholder: e.placeholder,
          maxlength: e.maxlength,
          disabled: e.disabled,
          onFocus: Q,
          onBlur: D,
          onInput: F,
          onChange: R,
          onKeydown: U(X(W, ["prevent"]), ["enter"])
        }, null, 40, ee),
        P.value ? (o(), n("span", te, [
          B.value ? (o(), n("span", {
            key: 0,
            class: f(["input-actions", { "clear-hidden": !e.value }]),
            onClick: j
          }, a[0] || (a[0] = [
            s("svg", {
              class: "clear-svg",
              focusable: "false",
              "data-icon": "close-circle",
              width: "1em",
              height: "1em",
              fill: "currentColor",
              "aria-hidden": "true",
              viewBox: "64 64 896 896"
            }, [
              s("path", { d: "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448 448-200.6 448-448S759.4 64 512 64zm165.4 618.2l-66-.3L512 563.4l-99.3 118.4-66.1.3c-4.4 0-8-3.5-8-8 0-1.9.7-3.7 1.9-5.2l130.1-155L340.5 359a8.32 8.32 0 01-1.9-5.2c0-4.4 3.6-8 8-8l66.1.3L512 464.6l99.3-118.4 66-.3c4.4 0 8 3.5 8 8 0 1.9-.7 3.7-1.9 5.2L553.5 514l130 155c1.2 1.5 1.9 3.3 1.9 5.2 0 4.4-3.6 8-8 8z" })
            ], -1)
          ]), 2)) : u("", !0),
          e.password ? (o(), n("span", {
            key: 1,
            class: "input-actions",
            onClick: H
          }, [
            $((o(), n("svg", ae, a[1] || (a[1] = [
              s("path", { d: "M942.2 486.2C847.4 286.5 704.1 186 512 186c-192.2 0-335.4 100.5-430.2 300.3a60.3 60.3 0 000 51.5C176.6 737.5 319.9 838 512 838c192.2 0 335.4-100.5 430.2-300.3 7.7-16.2 7.7-35 0-51.5zM512 766c-161.3 0-279.4-81.8-362.7-254C232.6 339.8 350.7 258 512 258c161.3 0 279.4 81.8 362.7 254C791.5 684.2 673.4 766 512 766zm-4-430c-97.2 0-176 78.8-176 176s78.8 176 176 176 176-78.8 176-176-78.8-176-176-176zm0 288c-61.9 0-112-50.1-112-112s50.1-112 112-112 112 50.1 112 112-50.1 112-112 112z" }, null, -1)
            ]), 512)), [
              [L, r.value]
            ]),
            $((o(), n("svg", ne, a[2] || (a[2] = [
              s("path", { d: "M942.2 486.2Q889.47 375.11 816.7 305l-50.88 50.88C807.31 395.53 843.45 447.4 874.7 512 791.5 684.2 673.4 766 512 766q-72.67 0-133.87-22.38L323 798.75Q408 838 512 838q288.3 0 430.2-300.3a60.29 60.29 0 000-51.5zm-63.57-320.64L836 122.88a8 8 0 00-11.32 0L715.31 232.2Q624.86 186 512 186q-288.3 0-430.2 300.3a60.3 60.3 0 000 51.5q56.69 119.4 136.5 191.41L112.48 835a8 8 0 000 11.31L155.17 889a8 8 0 0011.31 0l712.15-712.12a8 8 0 000-11.32zM149.3 512C232.6 339.8 350.7 258 512 258c54.54 0 104.13 9.36 149.12 28.39l-70.3 70.3a176 176 0 00-238.13 238.13l-83.42 83.42C223.1 637.49 183.3 582.28 149.3 512zm246.7 0a112.11 112.11 0 01146.2-106.69L401.31 546.2A112 112 0 01396 512z" }, null, -1),
              s("path", { d: "M508 624c-3.46 0-6.87-.16-10.25-.47l-52.82 52.82a176.09 176.09 0 00227.42-227.42l-52.82 52.82c.31 3.38.47 6.79.47 10.25a111.94 111.94 0 01-112 112z" }, null, -1)
            ]), 512)), [
              [L, !r.value]
            ])
          ])) : u("", !0),
          e.showCount ? (o(), n("span", oe, p(q.value), 1)) : u("", !0),
          k.value ? (o(), n("span", le, [
            h(e.$slots, "suffix", {}, () => [
              m(p(e.suffix), 1)
            ], !0)
          ])) : u("", !0)
        ])) : u("", !0)
      ], 34),
      C.value ? (o(), n("span", {
        key: 1,
        class: f(["input-addon", { "addon-after": C.value }])
      }, [
        h(e.$slots, "addonAfter", {}, () => [
          m(p(e.addonAfter), 1)
        ], !0)
      ], 2)) : u("", !0)
    ], 4));
  }
});
export {
  ie as default
};
