import { defineComponent as D, ref as T, computed as o, createElementBlock as n, openBlock as l, normalizeStyle as W, unref as c, createCommentVNode as u, createElementVNode as r, normalizeClass as p, renderSlot as i, createTextVNode as f, toDisplayString as d, withKeys as z, withModifiers as S, createVNode as q, mergeProps as A, createSlots as F, withCtx as k } from "vue";
import G from "../button/index.js";
import { useInject as H, useSlotsExist as J } from "../utils/index.js";
const O = {
  key: 0,
  class: "input-search-prefix"
}, Q = ["value", "placeholder", "maxlength", "disabled", "onKeydown"], U = {
  key: 1,
  class: "input-search-suffix"
}, X = {
  key: 1,
  class: "input-search-count"
}, Y = {
  key: 2,
  class: "suffix-item"
}, Z = ["onKeydown"], te = /* @__PURE__ */ D({
  __name: "InputSearch",
  props: {
    width: { default: "100%" },
    icon: { type: Boolean, default: !0 },
    search: { default: void 0 },
    searchProps: { default: () => ({}) },
    size: { default: "middle" },
    allowClear: { type: Boolean, default: !1 },
    addonBefore: { default: void 0 },
    prefix: { default: void 0 },
    suffix: { default: void 0 },
    loading: { type: Boolean, default: !1 },
    disabled: { type: Boolean, default: !1 },
    placeholder: { default: void 0 },
    maxlength: { default: void 0 },
    showCount: { type: Boolean, default: !1 },
    value: { default: void 0 },
    valueModifiers: { default: () => ({}) }
  },
  emits: ["update:value", "change", "search"],
  setup(x, { emit: $ }) {
    const a = x, v = T(null), { colorPalettes: m, shadowColor: E } = H("InputSearch"), s = $, h = J(["prefix", "suffix", "addonBefore"]), I = o(() => typeof a.width == "number" ? `${a.width}px` : a.width), g = o(() => !a.disabled && a.allowClear), M = o(() => a.maxlength ? (a.value ? a.value.length : 0) + " / " + a.maxlength : a.value ? a.value.length : 0), K = o(() => h.prefix || a.prefix), w = o(() => h.suffix || a.suffix), L = o(() => g.value || a.showCount || w.value), y = o(() => h.addonBefore || a.addonBefore), C = o(() => "lazy" in a.valueModifiers);
    function N(e) {
      const t = e.target;
      C.value || (s("update:value", t.value), s("change", e));
    }
    function P(e) {
      const t = e.target;
      t.value !== a.value && (s("update:value", t.value), s("change", e));
    }
    function V() {
      var e;
      s("update:value", ""), (e = v.value) == null || e.focus();
    }
    async function R(e) {
      var B;
      const t = e.target;
      if (s("search", t.value, e), C.value) {
        const j = new Event("change");
        (B = e.target) == null || B.dispatchEvent(j);
      }
    }
    function b(e) {
      s("search", a.value, e);
    }
    return (e, t) => (l(), n("div", {
      class: "m-input-search",
      style: W(`
      --input-search-width: ${I.value};
      --input-search-primary-color-hover: ${c(m)[4]};
      --input-search-primary-color-focus: ${c(m)[4]};
      --input-search-primary-shadow-color: ${c(E)};
    `)
    }, [
      y.value ? (l(), n("span", {
        key: 0,
        class: p(["input-search-addon-before", `addon-before-${e.size}`])
      }, [
        i(e.$slots, "addonBefore", {}, () => [
          f(d(e.addonBefore), 1)
        ], !0)
      ], 2)) : u("", !0),
      r("div", {
        tabindex: "1",
        class: p(["input-search-wrap", [
          `input-search-${e.size}`,
          {
            "input-search-before": y.value,
            "input-search-disabled": e.disabled
          }
        ]])
      }, [
        K.value ? (l(), n("span", O, [
          i(e.$slots, "prefix", {}, () => [
            f(d(e.prefix), 1)
          ], !0)
        ])) : u("", !0),
        r("input", {
          ref_key: "inputRef",
          ref: v,
          class: "input-search",
          type: "text",
          value: e.value,
          placeholder: e.placeholder,
          maxlength: e.maxlength,
          disabled: e.disabled,
          onInput: N,
          onChange: P,
          onKeydown: z(S(R, ["prevent"]), ["enter"])
        }, null, 40, Q),
        L.value ? (l(), n("span", U, [
          g.value ? (l(), n("span", {
            key: 0,
            class: p(["input-search-clear", { "clear-hidden": !e.value }]),
            onClick: V
          }, t[0] || (t[0] = [
            r("svg", {
              class: "clear-svg",
              focusable: "false",
              "data-icon": "close-circle",
              width: "1em",
              height: "1em",
              fill: "currentColor",
              "aria-hidden": "true",
              viewBox: "64 64 896 896"
            }, [
              r("path", { d: "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448 448-200.6 448-448S759.4 64 512 64zm165.4 618.2l-66-.3L512 563.4l-99.3 118.4-66.1.3c-4.4 0-8-3.5-8-8 0-1.9.7-3.7 1.9-5.2l130.1-155L340.5 359a8.32 8.32 0 01-1.9-5.2c0-4.4 3.6-8 8-8l66.1.3L512 464.6l99.3-118.4 66-.3c4.4 0 8 3.5 8 8 0 1.9-.7 3.7-1.9 5.2L553.5 514l130 155c1.2 1.5 1.9 3.3 1.9 5.2 0 4.4-3.6 8-8 8z" })
            ], -1)
          ]), 2)) : u("", !0),
          e.showCount ? (l(), n("span", X, d(M.value), 1)) : u("", !0),
          w.value ? (l(), n("span", Y, [
            i(e.$slots, "suffix", {}, () => [
              f(d(e.suffix), 1)
            ], !0)
          ])) : u("", !0)
        ])) : u("", !0)
      ], 2),
      r("span", {
        class: "input-search-button",
        onClick: b,
        onKeydown: z(S(b, ["prevent"]), ["enter"])
      }, [
        i(e.$slots, "search", {}, () => [
          q(c(G), A({
            class: "search-btn",
            size: e.size,
            disabled: e.disabled,
            loading: e.loading
          }, e.searchProps), F({
            default: k(() => [
              f(" " + d(e.search), 1)
            ]),
            _: 2
          }, [
            e.icon ? {
              name: "icon",
              fn: k(() => [
                i(e.$slots, "icon", {}, () => [
                  t[1] || (t[1] = r("svg", {
                    focusable: "false",
                    "data-icon": "search",
                    width: "1em",
                    height: "1em",
                    fill: "currentColor",
                    "aria-hidden": "true",
                    viewBox: "64 64 896 896"
                  }, [
                    r("path", { d: "M909.6 854.5L649.9 594.8C690.2 542.7 712 479 712 412c0-80.2-31.3-155.4-87.9-212.1-56.6-56.7-132-87.9-212.1-87.9s-155.5 31.3-212.1 87.9C143.2 256.5 112 331.8 112 412c0 80.1 31.3 155.5 87.9 212.1C256.5 680.8 331.8 712 412 712c67 0 130.6-21.8 182.7-62l259.7 259.6a8.2 8.2 0 0011.6 0l43.6-43.5a8.2 8.2 0 000-11.6zM570.4 570.4C528 612.7 471.8 636 412 636s-116-23.3-158.4-65.6C211.3 528 188 471.8 188 412s23.3-116.1 65.6-158.4C296 211.3 352.2 188 412 188s116.1 23.2 158.4 65.6S636 352.2 636 412s-23.3 116.1-65.6 158.4z" })
                  ], -1))
                ], !0)
              ]),
              key: "0"
            } : void 0
          ]), 1040, ["size", "disabled", "loading"])
        ], !0)
      ], 40, Z)
    ], 4));
  }
});
export {
  te as default
};
